﻿package com
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	//import fl.text.TLFTextField;
	import flash.text.TextField;
	import flash.text.TextFormat;
 
	import flash.text.Font;
	import flash.utils.getDefinitionByName;
	
	public class Main extends MovieClip 
	{
		private var xmlLoader		: URLLoader;
		private var data			: XML;
		private var rangeStart		: Number;
		private var rangeEnd		: Number;
		private var currentDrag		: MovieClip;
		private var isReverse		: Boolean = false;
		public function Main() 
		{
			this.addEventListener(Event.ADDED_TO_STAGE, onAdded);			
		}
		
		private function onAdded(evt:Event = null):void {
			xmlLoader = new URLLoader();
			xmlLoader.addEventListener(Event.COMPLETE, onXMLLoaded);
			xmlLoader.load(new URLRequest("xml/config.xml"));			
		}
		
		private function onXMLLoaded(evt:Event):void {
			data = new XML(evt.target.data);			
			if(data.range.@reverse.length()>0){
				isReverse = (data.range.@reverse=="true") ? true : false;
			}
			rangeStart = Number(data.range.start.toString());
			rangeEnd = Number(data.range.end.toString());
			this.btn_5.buttonMode = true;
			this.btn_10.buttonMode = true;
			this.btn_20.buttonMode = true;
			this.btn_5.mouseChildren = false;
			this.btn_10.mouseChildren = false;
			this.btn_20.mouseChildren = false;
			addeventListeners();
			this.btn_5.addEventListener(MouseEvent.CLICK,function(){
				onBtnClicked(7);				
			});
			this.btn_10.addEventListener(MouseEvent.CLICK,function(){
				onBtnClicked(12);
			});
			this.btn_20.addEventListener(MouseEvent.CLICK,function(){
				onBtnClicked(22);
			});
			onBtnClicked(7);
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);						
		}
		private function addeventListeners():void{
			this.btn_5.addEventListener(MouseEvent.MOUSE_OUT,onButtonMouseOut);
			this.btn_5.addEventListener(MouseEvent.MOUSE_OVER,onButtonMouseOver);		
			this.btn_10.addEventListener(MouseEvent.MOUSE_OUT,onButtonMouseOut);
			this.btn_10.addEventListener(MouseEvent.MOUSE_OVER,onButtonMouseOver);	
			this.btn_20.addEventListener(MouseEvent.MOUSE_OUT,onButtonMouseOut);
			this.btn_20.addEventListener(MouseEvent.MOUSE_OVER,onButtonMouseOver);

		}
		
		private function removeeventListeners(_btn):void{
			_btn.removeEventListener(MouseEvent.MOUSE_OUT,onButtonMouseOut);
			_btn.removeEventListener(MouseEvent.MOUSE_OVER,onButtonMouseOver);	

			
		}
		
		public function onButtonMouseOut(eve:MouseEvent =null):void{
			var targetClip = eve.target;
			targetClip.gotoAndStop(1);
		}
		public function onButtonMouseOver(eve:MouseEvent =null):void{
			var targetClip = eve.target;
			targetClip.gotoAndStop(2);
			
		}
		private function onBtnClicked(btnId:Number):void{
			rangeStart = 0;
			rangeEnd = btnId;
			addeventListeners();
			switch(btnId){
				case 7:
					removeeventListeners(this.btn_5);
					this.btn_5.gotoAndStop(3);
					this.btn_10.gotoAndStop(1);
					this.btn_20.gotoAndStop(1);
				break;
				case 12:
					removeeventListeners(this.btn_10);
					this.btn_5.gotoAndStop(1);
					this.btn_10.gotoAndStop(3);
					this.btn_20.gotoAndStop(1);
				break;
				case 22:
					removeeventListeners(this.btn_20);
					this.btn_5.gotoAndStop(1);
					this.btn_10.gotoAndStop(1);
					this.btn_20.gotoAndStop(3);
				break;
			}
			onReset();
		}
		private function onReset(eve:MouseEvent=null):void {
			var drop:MovieClip;
			var drag:MovieClip;
			for (var i:int = 0; i < data.content.lozenges.item.length(); i++) {
				drop = getChildByName("drop_" + i) as MovieClip; 
				if(drop!=null) removeChild(drop);
			}
			for (i = 0; i < data.content.sentences.item.length(); i++) {
				drag = getChildByName("drag_" + i) as MovieClip;
				if(drag!=null) removeChild(drag);
			}
			if ( getChildByName("feedback") != null ) {
				removeChild(getChildByName("feedback"));
			}
			createDropElements();
			createDragElement();

		}
		
		private function createDropElements():void {
			var drop:MovieClip;
			for (var i:int = 0; i < data.content.lozenges.item.length(); i++) {
				drop = new MovieClip();
				drop.name = "drop_" + i;
				drop.graphics.lineStyle(Number(data.content.lozenges.@borderSize), Number(data.content.lozenges.@borderColor), 1);
				drop.graphics.beginFill(Number(data.content.lozenges.@backgroundColor), 1);
				drop.graphics.drawRect(0, 0, Number(data.content.lozenges.@width), Number(data.content.lozenges.@height));
				drop.graphics.lineStyle(Number(data.content.lozenges.@borderSize), Number(data.content.lozenges.@borderColor), 0);
				drop.graphics.beginFill(Number(data.content.lozenges.@backgroundColor), 0);
				drop.graphics.drawRect(0, -Number(data.content.sentences.@height), Number(data.content.sentences.@width), Number(data.content.sentences.@height));
				drop.x = Number(data.content.lozenges.item[i].@xpos);
				drop.y = Number(data.content.lozenges.item[i].@ypos);
				drop.dropped = false;
				drop.drag = null;
				addChild(drop);
			}
		}
		
		private function createDragElement():void {
			var drag:MovieClip;
			var txtFld:TextField;
			var txtFormat:TextFormat;
			var startNumber:Number = int(Math.random() * (rangeEnd - Number(data.content.@numberOfDrag)) + rangeStart);
			var dragNumber:Array = new Array();
			var rand:Number;
			var flag:Boolean;
			txtFormat = new TextFormat();
			
			var fnt=getDefinitionByName(data.content.@font) as Class;
			var fon:Font=new fnt();
			txtFormat.font = fon.fontName;
			
			txtFormat.size = Number(data.content.@fontSize);
			txtFormat.color = uint(data.content.@fontColor);
			while (dragNumber.length != data.content.sentences.item.length()) {
				flag = false;
				rand = int(Math.random() * 5);
				for(var j:int = 0; j < dragNumber.length; j++) {
					if ( dragNumber[j] == rand ) {
						flag = true;
						j = dragNumber.length;
					}
				}
				if ( !flag ) {
					dragNumber.push(rand);
				}
			}
			for (var i:int = 0; i < data.content.sentences.item.length(); i++) {
				drag = new MovieClip();
				drag.name = "drag_" + i;
				drag.mouseChildren = false;
				drag.tabEnabled = false;
				drag.tabChildren = false;
				drag.graphics.lineStyle(Number(data.content.sentences.@borderSize), Number(data.content.sentences.@borderColor), 1);
				drag.graphics.beginFill(Number(data.content.sentences.@backgroundColor), 1);
				drag.graphics.drawRect(0, 0, Number(data.content.sentences.@width), Number(data.content.sentences.@height));
				drag.x = Number(data.content.sentences.item[i].@xpos);
				drag.y = Number(data.content.sentences.item[i].@ypos);
				drag.xx = drag.x;
				drag.yy = drag.y;
				addChild(drag);
				txtFld = new TextField();
				txtFld.text = (startNumber + dragNumber[i]) + "";
				txtFld.selectable = false;
				txtFld.autoSize = "left";
				txtFld.setTextFormat(txtFormat);
				txtFld.x = drag.width / 2 - txtFld.width / 2 - 2;
				txtFld.y = drag.height / 2 - txtFld.height / 2;
				txtFld.embedFonts=true;
				drag.number = dragNumber[i];
				drag.drop = -1;
				drag.addChild(txtFld);	
				drag.addEventListener(MouseEvent.MOUSE_DOWN, onStartDrag);
				
			}
		}
		
		private function onStartDrag(evt:MouseEvent):void {
			currentDrag = evt.target as MovieClip;
			setChildIndex(currentDrag, numChildren - 1);
			currentDrag.startDrag(false,new Rectangle(0,0,640,250));
			stage.addEventListener(MouseEvent.MOUSE_UP, onStopDrag);
		}
		
		private function onStopDrag(evt:MouseEvent):void {
			var drop:MovieClip;
			var drag:MovieClip;
			var dropNumber:Number = -1;
			var rect1:Rectangle;
			var rect2:Rectangle;
			var count:Number = 0;
			var answerCount:Number = 0;
			var feedback:MovieClip;
			var dropId:Number = 0;			
			
			for (var i:int = 0; i < data.content.lozenges.item.length(); i++) {
				drop = getChildByName("drop_" + i) as MovieClip;
				rect1 = currentDrag.getBounds(stage);
				rect2 = drop.getBounds(stage);
				if ( rect1.intersection(rect2).width != 0 && rect1.intersection(rect2).height != 0 ) {
					dropNumber = i;
					break;
				}
			}
			if ( dropNumber != -1 ) {
				drop = getChildByName("drop_" + dropNumber) as MovieClip;
				if ( drop.dropped == false ) {
					currentDrag.x = drop.x;
					currentDrag.y = drop.y + drop.height - 2 * currentDrag.height;
					currentDrag.drop = dropNumber;
					drop.dropped = true;
					drop.drag = currentDrag;
					currentDrag.removeEventListener(MouseEvent.MOUSE_DOWN, onStartDrag);
					currentDrag.stopDrag();
					stage.removeEventListener(MouseEvent.MOUSE_UP, onStopDrag);
				} else {
					if ( drop.drag != null ) {
						drop.drag.x = drop.drag.xx;
						drop.drag.y = drop.drag.yy;
						drop.drag.drop = -1;
						drop.drag.addEventListener(MouseEvent.MOUSE_DOWN, onStartDrag);
						currentDrag.x = drop.x;
						currentDrag.y = drop.y + drop.height - 2 * currentDrag.height;
						currentDrag.drop = dropNumber;
						drop.dropped = true;
						drop.drag = currentDrag;
						currentDrag.removeEventListener(MouseEvent.MOUSE_DOWN, onStartDrag);
						currentDrag.stopDrag();
						stage.removeEventListener(MouseEvent.MOUSE_UP, onStopDrag);
					} 
				}
			} 
			
			for (i = 0; i < data.content.sentences.item.length(); i++) {
				drag = getChildByName("drag_" + i) as MovieClip;
				if ( drag.drop != -1 ) {
					count++;
					if(isReverse){
						dropId = data.content.sentences.item.length() - drag.drop -1;
					}else{
						dropId =  drag.drop
					}
					if ( drag.number == dropId) {
						answerCount++;
					}					
				}
			}
			if ( count == data.content.sentences.item.length() ) {
				feedback = new Feedback();
				feedback.name = "feedback";
				if ( answerCount == count ) {
					feedback.gotoAndStop(1);
				} else {
					feedback.gotoAndStop(2);
				}
				feedback.x = Number(data.feedback.@x);
				feedback.y = Number(data.feedback.@y);
				addChild(feedback);
			}			
		}
		
	}

}