﻿package com 
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	//import fl.text.TLFTextField;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	import flash.text.Font;
	import flash.utils.getDefinitionByName;
	public class Main extends MovieClip 
	{
		private var xmlLoader			: URLLoader;
		private var data				: XML;
		private var rangeArr			: Array;
		private var rangeStart			: Number;
		private var rangeEnd			: Number;
		private var currentDrag			: MovieClip;
		private var selectedRangeIndex	: Number;
		private var selectedColor		: uint = 0x01679A;
		private var normalColor			: uint = 0xFFFFFF;
		
		public function Main() 
		{
			this.addEventListener(Event.ADDED_TO_STAGE, onAdded);			
		}
		
		private function onAdded(evt:Event = null):void {
			
			xmlLoader = new URLLoader();
			xmlLoader.addEventListener(Event.COMPLETE, onXMLLoaded);
			xmlLoader.load(new URLRequest("xml/config.xml"));
			this.removeEventListener(Event.ADDED_TO_STAGE, onAdded);
		}
		
		private function onXMLLoaded(evt:Event):void {
			var range:Object;
			var button:MovieClip;
			var textFormat:TextFormat = new TextFormat();
			data = new XML(evt.target.data);
			rangeArr = new Array();
			selectedRangeIndex = 1;
			for (var i:int = 0; i < data.range.item.length(); i++) {
				button = getChildByName("btn_" + (i + 1)) as MovieClip;
				range = new Object();
				range.start = Number(data.range.item[i].@start);
				range.end = Number(data.range.item[i].@end);
				rangeArr.push(range);
				button.title.text = range.start +"–" + range.end;
				button.mouseChildren = false;
				button.buttonMode = true;
				button.useHandCursor = true;
				button.gotoAndStop(1);
				button.addEventListener(MouseEvent.MOUSE_OUT,onButtonMouseOut);
				button.addEventListener(MouseEvent.MOUSE_OVER,onButtonMouseOver);				
				button.addEventListener(MouseEvent.CLICK, onButtonSelected);
			}		
			rangeStart = rangeArr[selectedRangeIndex].start;
			rangeEnd = rangeArr[selectedRangeIndex].end;
			button = getChildByName("btn_" + (selectedRangeIndex + 1)) as MovieClip;
			button.removeEventListener(MouseEvent.MOUSE_OUT,onButtonMouseOut);
			button.removeEventListener(MouseEvent.MOUSE_OVER,onButtonMouseOver);	
			textFormat.color = selectedColor;
			button.title.setTextFormat(textFormat);
			
			createDropElements();
			createDragElement();	
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
		}
		
		public function onButtonMouseOut(eve:MouseEvent =null):void{
			var targetClip = eve.target;
			targetClip.gotoAndStop(1);
		}
		public function onButtonMouseOver(eve:MouseEvent =null):void{
			var targetClip = eve.target;
			targetClip.gotoAndStop(2);
			
		}
		public function onReset(evt:MouseEvent = null ):void {
			var drop:MovieClip;
			var drag:MovieClip;
			var button:MovieClip;
			var textFormat:TextFormat = new TextFormat();
			textFormat.color = selectedColor;
			for (var i:int = 0; i < data.content.lozenges.item.length(); i++) {
				drop = getChildByName("drop_" + i) as MovieClip; 
				removeChild(drop);
			}
			for (i = 0; i < data.content.sentences.item.length(); i++) {
				drag = getChildByName("drag_" + i) as MovieClip;
				removeChild(drag);
			}
			if ( getChildByName("feedback") != null ) {
				removeChild(getChildByName("feedback"));
			}
			/*textFormat.color = normalColor;
			for (i = 0; i < data.range.item.length(); i++) {
				button = getChildByName("btn_" + (i + 1)) as MovieClip;
				button.title.setTextFormat(textFormat);
			}
			selectedRangeIndex = 1;
			button = getChildByName("btn_2") as MovieClip;
			textFormat.color = selectedColor;
			button.title.setTextFormat(textFormat);*/
			createDropElements();
			createDragElement();
		}
		
		private function onButtonSelected(evt:MouseEvent):void {
			
			for (var ii:int = 0; ii < data.range.item.length(); ii++) {
				button = getChildByName("btn_" + (ii + 1)) as MovieClip;
				button.addEventListener(MouseEvent.MOUSE_OUT,onButtonMouseOut);
				button.addEventListener(MouseEvent.MOUSE_OVER,onButtonMouseOver);				
			}		
			
			
			var button:MovieClip = evt.target as MovieClip;
			button.removeEventListener(MouseEvent.MOUSE_OUT,onButtonMouseOut);
			button.removeEventListener(MouseEvent.MOUSE_OVER,onButtonMouseOver);		
			var drag:MovieClip;
			var drop:MovieClip;
			var targetClip = evt.target;
			targetClip.gotoAndStop(3);
			var textFormat:TextFormat = new TextFormat();
			selectedRangeIndex = Number(button.name.split("_")[1]) - 1;
			rangeStart = rangeArr[selectedRangeIndex].start;
			rangeEnd = Number(rangeArr[selectedRangeIndex].end) + 1;
			textFormat.color = normalColor;
			for (var i:int = 0; i < data.range.item.length(); i++) {
				button = getChildByName("btn_" + (i + 1)) as MovieClip;
				button.title.setTextFormat(textFormat);
			}
			textFormat.color = selectedColor;
			button = evt.target as MovieClip;
			button.title.setTextFormat(textFormat);
			for (i = 0; i < data.content.sentences.item.length(); i++) {
				drag = getChildByName("drag_" + i) as MovieClip;
				removeChild(drag);
			}
			for (i = 0; i < data.content.lozenges.item.length(); i++) {
				drop = getChildByName("drop_" + i) as MovieClip;
				drop.dropped = false;
			}
			if ( getChildByName("feedback") != null ) {
				removeChild(getChildByName("feedback"));
			}
			createDragElement();
		}
		
		private function createDropElements():void {
			var drop:MovieClip;
			for (var i:int = 0; i < data.content.lozenges.item.length(); i++) {
				drop = new MovieClip();
				drop.name = "drop_" + i;
				drop.graphics.lineStyle(Number(data.content.lozenges.@borderSize), Number(data.content.lozenges.@borderColor), 1);
				drop.graphics.beginFill(Number(data.content.lozenges.@backgroundColor), 1);
				drop.graphics.drawRect(0, 0, Number(data.content.lozenges.@width), Number(data.content.lozenges.@height));
				drop.graphics.lineStyle(Number(data.content.lozenges.@borderSize), Number(data.content.lozenges.@borderColor), 0);
				drop.graphics.beginFill(Number(data.content.lozenges.@backgroundColor), 0);
				drop.graphics.drawRect(0, -Number(data.content.sentences.@height), Number(data.content.sentences.@width), Number(data.content.sentences.@height));
				drop.x = Number(data.content.lozenges.item[i].@xpos);
				drop.y = Number(data.content.lozenges.item[i].@ypos);
				drop.drag = null;
				drop.dropped = false;
				addChild(drop);
			}
		}
		
		private function createDragElement():void {
			trace("in")
			var drag:MovieClip;
			var txtFld:TextField;
			var txtFormat:TextFormat;
			var startNumber:Number = int(Math.random() * (rangeEnd - Number(data.content.@numberOfDrag)) + rangeStart);
			var dragNumber:Array = new Array();
			var rand:Number;
			var flag:Boolean;
			txtFormat = new TextFormat();
			var fnt=getDefinitionByName(data.content.@fontId) as Class;
			var fon:Font=new fnt();
			txtFormat.font = fon.fontName;
			txtFormat.size = Number(data.content.@fontSize);
			txtFormat.color = uint(data.content.@fontColor);
			while (dragNumber.length != data.content.sentences.item.length()) {
				flag = false;
				rand = int(Math.random() * 5);
				for(var j:int = 0; j < dragNumber.length; j++) {
					if ( dragNumber[j] == rand ) {
						flag = true;
						j = dragNumber.length;
					}
				}
				if ( !flag ) {
					dragNumber.push(rand);
				}
			}
			for (var i:int = 0; i < data.content.sentences.item.length(); i++) {
				drag = new MovieClip();
				drag.name = "drag_" + i;
				drag.mouseChildren = false;
				drag.tabEnabled = false;
				drag.tabChildren = false;
				drag.graphics.lineStyle(Number(data.content.sentences.@borderSize), Number(data.content.sentences.@borderColor), 1);
				drag.graphics.beginFill(Number(data.content.sentences.@backgroundColor), 1);
				drag.graphics.drawRect(0, 0, Number(data.content.sentences.@width), Number(data.content.sentences.@height));
				drag.x = Number(data.content.sentences.item[i].@xpos);
				drag.y = Number(data.content.sentences.item[i].@ypos);
				drag.xx = drag.x;
				drag.yy = drag.y;
				addChild(drag);
				txtFld = new TextField();
				txtFld.text = (startNumber + dragNumber[i]) + "";
				txtFld.selectable = false;
				txtFld.autoSize = "left";
				txtFld.embedFonts=true;
				txtFld.setTextFormat(txtFormat);
				txtFld.x = drag.width / 2 - txtFld.width / 2 - 2;
				txtFld.y = drag.height / 2 - txtFld.height / 2;
				drag.number = dragNumber[i];
				drag.drop = -1;
				drag.addChild(txtFld);	
				drag.addEventListener(MouseEvent.MOUSE_DOWN, onStartDrag);
				
			}
		}
		
		private function onStartDrag(evt:MouseEvent):void {
			currentDrag = evt.target as MovieClip;
			setChildIndex(currentDrag, numChildren - 1);
			currentDrag.startDrag(false,new Rectangle(0,0,640,250));
			stage.addEventListener(MouseEvent.MOUSE_UP, onStopDrag);
			if ( getChildByName("feedback") != null ) {
				removeChild(getChildByName("feedback"));
			}
		}
		
		private function onStopDrag(evt:MouseEvent):void {
			var drop:MovieClip;
			var drag:MovieClip;
			var dropNumber:Number = -1;
			var rect1:Rectangle;
			var rect2:Rectangle;
			var count:Number = 0;
			var answerCount:Number = 0;
			var feedback:MovieClip;
			/*currentDrag.stopDrag();			
			stage.removeEventListener(MouseEvent.MOUSE_UP, onStopDrag);*/
			for (var i:int = 0; i < data.content.lozenges.item.length(); i++) {
				drop = getChildByName("drop_" + i) as MovieClip;
				rect1 = currentDrag.getBounds(stage);
				rect2 = drop.getBounds(stage);
				if ( rect1.intersection(rect2).width != 0 && rect1.intersection(rect2).height != 0 ) {
					dropNumber = i;
					break;
				}
			}
			if ( dropNumber != -1 ) {
				drop = getChildByName("drop_" + dropNumber) as MovieClip;
				if ( !drop.dropped ) {
					currentDrag.x = drop.x;
					currentDrag.y = drop.y + drop.height - 2 * currentDrag.height;
					currentDrag.drop = dropNumber;
					currentDrag.removeEventListener(MouseEvent.MOUSE_DOWN, onStartDrag);
					drop.dropped = true;	
					drop.drag = currentDrag;
					currentDrag.stopDrag();			
					stage.removeEventListener(MouseEvent.MOUSE_UP, onStopDrag);
				} else {
					if ( drop.drag != null ) {
						drop.drag.x = drop.drag.xx;
						drop.drag.y = drop.drag.yy;
						drop.drag.drop = -1;
						drop.drag.addEventListener(MouseEvent.MOUSE_DOWN, onStartDrag);
						currentDrag.x = drop.x;
						currentDrag.y = drop.y + drop.height - 2 * currentDrag.height;
						currentDrag.drop = dropNumber;
						drop.dropped = true;
						drop.drag = currentDrag;
						currentDrag.removeEventListener(MouseEvent.MOUSE_DOWN, onStartDrag);
						currentDrag.stopDrag();			
						stage.removeEventListener(MouseEvent.MOUSE_UP, onStopDrag);
					} /*else {
						currentDrag.x = currentDrag.xx;
						currentDrag.y = currentDrag.yy;
						currentDrag.drop = -1;
					}*/
				}
			} /*else {
				currentDrag.x = currentDrag.xx;
				currentDrag.y = currentDrag.yy;
				currentDrag.drop = -1;
			}	*/
			for (i = 0; i < data.content.sentences.item.length(); i++) {
				drag = getChildByName("drag_" + i) as MovieClip;
				if ( drag.drop != -1 ) {
					count++;
					if ( drag.number == drag.drop ) {
						answerCount++;
					}					
				}
			}
			if ( count == data.content.sentences.item.length() ) {
				feedback = new Feedback();
				feedback.name = "feedback";
				if ( answerCount == count ) {
					feedback.gotoAndStop(1);
				} else {
					feedback.gotoAndStop(2);
				}
				feedback.x = Number(data.content.@feedbackXPos);
				feedback.y = Number(data.content.@feedbackYPos);
				addChild(feedback);
			}			
		}
		
	}

}