﻿package com{
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	
	import flash.text.Font;
	import flash.utils.getDefinitionByName;
	
	public class PictureCounting {
		private var targetClip:MovieClip;
		private var xmlData:XML;
		private var pageArr:Array;
		private var currLeftPage:Number;
		private var currRightPage:Number;
		private var isDragging:Boolean;
		private var fromRange:Number;
		private var toRange:Number;

		public function PictureCounting(target:MovieClip):void {
			targetClip=target;
			targetClip.visible = false;
			xmlData = new XML();
			pageArr = new Array();
			isDragging = false;
			currLeftPage = -1;
		}
		public function setUp(url:String):void {
			enableBtns(false);
			loadXML(url);
		}		
		private function randomRange(prevRndNum:Number,max:Number, min:Number = 0):Number
		{
			if(max == min) return max;
			var currRnd:Number = Math.round(Math.random() * (max - min) + min);
			var prevRnd:Number = prevRndNum;
			if(prevRnd == currRnd){
				currRnd = randomRange(prevRnd,max,min);
			}	
			return currRnd;
		}				
		private function enableBtns(val:Boolean):void{
			targetClip.reset_btn.enabled = val;
			targetClip.numBtn.enabled = val;
			targetClip.wordBtn.enabled = val;
			targetClip.selRangeBtn.enabled = val;
			targetClip.rndBtn.enabled = val;
			
			if(val){
				targetClip.reset_btn.alpha = targetClip.rndBtn.alpha = 1;
				targetClip.reset_btn.addEventListener(MouseEvent.CLICK,function(){
						targetClip.rndBtn.visible = false;
									
						targetClip.numBtn.gotoAndStop(1);
						targetClip.wordBtn.gotoAndStop(3);		
						removeEventlisteners(targetClip.wordBtn);
						reset();
				});
				targetClip.rndBtn.fromUpBtn.buttonMode = true;
				targetClip.rndBtn.fromDownBtn.buttonMode = true;
				targetClip.rndBtn.toUpBtn.buttonMode = true;
				targetClip.rndBtn.toDownBtn.buttonMode = true;
				targetClip.rndBtn.fromUpBtn.addEventListener(MouseEvent.CLICK,updateRangeVal);
				targetClip.rndBtn.fromDownBtn.addEventListener(MouseEvent.CLICK,updateRangeVal);
				targetClip.rndBtn.toUpBtn.addEventListener(MouseEvent.CLICK,updateRangeVal);
				targetClip.rndBtn.toDownBtn.addEventListener(MouseEvent.CLICK,updateRangeVal);
				updateRangeVal();		
				targetClip.selRangeBtn.mouseChildren = false;
				targetClip.selRangeBtn.buttonMode =true;
				targetClip.wordBtn.mouseChildren = false;
				targetClip.wordBtn.buttonMode =true;
				targetClip.numBtn.mouseChildren = false;
				targetClip.numBtn.buttonMode =true;
				addEventlisteners();
				
				targetClip.numBtn.gotoAndStop(1);
				targetClip.wordBtn.gotoAndStop(3);		
				removeEventlisteners(targetClip.wordBtn);
			}else{
				targetClip.reset_btn.alpha = targetClip.rndBtn.alpha = 0.5;
			}
			targetClip.addEventListener(MouseEvent.MOUSE_UP,onStageClicked);
		}
		private function onMouseOver(eve:MouseEvent =null):void{
			var button = eve.target
			button.gotoAndStop(2)
		}
		private function onMouseOut(eve:MouseEvent =null):void{
			var button = eve.target
			button.gotoAndStop(1)
		}

		private function onMousedown(eve:MouseEvent =null):void{
			var button = eve.target
			button.gotoAndStop(3)
		}
		private function onMouseup(eve:MouseEvent =null):void{
			var button = eve.target
			button.gotoAndStop(1)
		}
		private function addEventlisteners(){
			
			targetClip.selRangeBtn.addEventListener(MouseEvent.MOUSE_OVER,onMouseOver);
			targetClip.selRangeBtn.addEventListener(MouseEvent.MOUSE_OUT,onMouseOut);
			targetClip.selRangeBtn.addEventListener(MouseEvent.MOUSE_DOWN,onMousedown);
			targetClip.selRangeBtn.addEventListener(MouseEvent.MOUSE_UP,onMouseup);
			targetClip.selRangeBtn.addEventListener(MouseEvent.CLICK,selRangeBtnClicked);			
			
			targetClip.numBtn.addEventListener(MouseEvent.MOUSE_OVER,onMouseOver);
			targetClip.numBtn.addEventListener(MouseEvent.MOUSE_OUT,onMouseOut);
			targetClip.numBtn.addEventListener(MouseEvent.CLICK,onMouseClick);
			
			targetClip.wordBtn.addEventListener(MouseEvent.MOUSE_OVER,onMouseOver);
			targetClip.wordBtn.addEventListener(MouseEvent.MOUSE_OUT,onMouseOut);
			targetClip.wordBtn.addEventListener(MouseEvent.CLICK,onMouseClick);
		}
		private function removeEventlisteners(tagetClip){

			tagetClip.removeEventListener(MouseEvent.MOUSE_OVER,onMouseOver);
			tagetClip.removeEventListener(MouseEvent.MOUSE_OUT,onMouseOut);

		}
		private function addEventlistener(tagetClip){
			tagetClip.addEventListener(MouseEvent.MOUSE_OVER,onMouseOver);
			tagetClip.addEventListener(MouseEvent.MOUSE_OUT,onMouseOut);
			tagetClip.gotoAndStop(1);
		}
		private function selRangeBtnClicked(ev:MouseEvent=null):void{
			targetClip.rndBtn.visible = !targetClip.rndBtn.visible;
		}
		private function onMouseClick(eve:MouseEvent=null):void{
			var button = eve.target
			button.gotoAndStop(3);
			removeEventlisteners(button);
			if(button.name == "wordBtn"){
				addEventlistener(targetClip.numBtn);
			}else{
				addEventlistener(targetClip.wordBtn)
			}
			reset();

		}

		private function loadXML(path:String) {
			var urlRequest:URLRequest=new URLRequest(path);
			var urlLoader:URLLoader=new URLLoader(urlRequest);
			urlLoader.addEventListener(Event.COMPLETE, xmlLoaded);
		}
		private function xmlLoaded(e:Event):void {
			xmlData=new XML(e.target.data);
			fromRange = Number(xmlData.numbers.number[0].@no);
			toRange = Number(xmlData.numbers.number[xmlData.numbers.children().length()-1].@no);
			targetClip.selRangeBtn.visible = true;
			targetClip.rndBtn.visible = false;
			enableBtns(true);
			reset();			
			targetClip.visible = true;
		}
		public function reset():void {
			pageArr=[];
			currLeftPage = randomRange(currLeftPage,fromRange,toRange);		
			var dupSmallPage:MovieClip = targetClip.getChildByName("dupSmallPage") as MovieClip;
			if(dupSmallPage!=null) targetClip.removeChild(dupSmallPage);
			isDragging = false;		
			
			if (targetClip.getChildByName("cakesClip")!=null) {
				targetClip.removeChild(targetClip.getChildByName("cakesClip"));
			}
			if (targetClip.getChildByName("numbersClip")!=null) {
				targetClip.removeChild(targetClip.getChildByName("numbersClip"));
			}
			if (targetClip.getChildByName("feedback")!=null) {
				targetClip.removeChild(targetClip.getChildByName("feedback"));
			}
			addNumbers();
			addAnswer();
			loadTray();
			drawFeedback();
		}
		private function resizePage(page:MovieClip, w:Number, h:Number):void {
			page.bg.x=0;
			page.bg.y=0;
			page.bg.width=w;
			page.bg.height=h;			
			//if (page.border.visible) {
				page.border.right.height=h;
				page.border.top.width=w;
				page.border.left.height=h;
				page.border.bottom.width=w;

				page.border.left.x=0;
				page.border.left.y=0;
				page.border.top.x=0;
				page.border.top.y=0;

				page.border.right.x=page.border.top.x+page.border.top.width-page.border.right.width;
				page.border.right.y=0;
				page.border.bottom.x=0;
				page.border.bottom.y=page.border.left.y+page.border.left.height-page.border.bottom.height;
			//}
		}
		private function drawPage(w:Number, h:Number, fillColor:Number, fillAlpha:Number, borderSize:Number, borderColor:Number):MovieClip {
			var page:Page = new Page();
			var pageColorTrans:ColorTransform = new ColorTransform();
			pageColorTrans.color=fillColor;
			page.bg.transform.colorTransform=pageColorTrans;
			page.bg.alpha=fillAlpha;
			page.border.visible = (borderSize>0) ? true : false;
			if (page.border.visible) {
				var borderColorTrans:ColorTransform = new ColorTransform();
				borderColorTrans.color=borderColor;
				page.border.transform.colorTransform=borderColorTrans;

				page.border.left.width=borderSize;
				page.border.right.width=borderSize;
				page.border.top.height=borderSize;
				page.border.bottom.height=borderSize;
			}
			resizePage(page,w,h);
			return page;
		}
		private function addTxt(txtStr:String):TextField{
			var txt:TextField = new TextField();
			txt.selectable = false;
			txt.background = false;
			txt.border = false;
			txt.autoSize = TextFieldAutoSize.LEFT;
			txt.text = txtStr;			
			txt.embedFonts=true;
			return txt;
		}
		private function changeFormat(targetTxt:TextField,font:String,fontSize:Number,fontColor:uint):void{
			var txt:TextField = targetTxt;
			var txtFormat:TextFormat = new TextFormat();
			txtFormat.leftMargin = 0;
			txtFormat.rightMargin = 0;
			txtFormat.font = font;
			txtFormat.bold = true;			
			txtFormat.size = fontSize;
			txtFormat.color = fontColor;
			
			txt.setTextFormat(txtFormat);
		}
		private function addNumbers():void {
			pageArr = [];
			var len:Number=xmlData.numbers.children().length();			
			var numbersClip:MovieClip = targetClip.getChildByName("numbersClip") as MovieClip;
			if(numbersClip!=null) targetClip.removeChild(numbersClip);
			numbersClip = new MovieClip();
			numbersClip.name="numbersClip";
			
			var prevnumber:MovieClip;
			for (var i:Number=Number(targetClip.rndBtn.fromTxt.text)-1; i<Number(targetClip.rndBtn.toTxt.text); i++) {
				pageArr[i] = ({no:xmlData.numbers.number[i].@no,word:xmlData.numbers.number[i].@word});				
				var str:String = (targetClip.numBtn.currentFrame==3) ? pageArr[i].no : pageArr[i].word;
				var number:MovieClip = new MovieClip();
				number.name="number_"+i;
				var txt:TextField = addTxt(str);
				txt.name = "txt";
				var font:String = (targetClip.numBtn.currentFrame==3) ? xmlData.numbers.@no_font : xmlData.numbers.@word_font;
				var fontSize:Number = (targetClip.numBtn.currentFrame==3) ? Number(xmlData.numbers.@no_fontSize) : Number(xmlData.numbers.@word_fontSize);
				var fontColor:uint = (targetClip.numBtn.currentFrame==3) ? uint(xmlData.numbers.@no_fontColor) : uint(xmlData.numbers.@word_fontColor);
				var gap:Number = (targetClip.numBtn.currentFrame==3) ?  Number(xmlData.numbers.@no_gap) : Number(xmlData.numbers.@word_gap);
				
				var fnt=getDefinitionByName(font) as Class;
				var fon:Font=new fnt();
				
				changeFormat(txt,fon.fontName,fontSize,fontColor);
				number.addChild(txt);
				prevnumber = numbersClip.getChildByName("number_"+(i-1)) as MovieClip;				
				number.x =(prevnumber==null) ?  0 : (prevnumber.x + prevnumber.width + gap);
				number.y = 0;
				
				number.buttonMode=true;
				number.mouseChildren = false;
				number.addEventListener(MouseEvent.MOUSE_DOWN,numberClicked);
				numbersClip.addChild(number);
			}
			if(targetClip.numBtn.currentFrame==3){
				numbersClip.x = (xmlData.numbers.@no_x.length>0) ? Number(xmlData.numbers.@no_x) : targetClip.boundary.x + (targetClip.boundary.width - numbersClip.width)/2;
				numbersClip.y = Number(xmlData.numbers.@no_y);
			}else{
				numbersClip.x = (xmlData.numbers.@word_x.length>0) ? Number(xmlData.numbers.@word_x) : targetClip.boundary.x + (targetClip.boundary.width - numbersClip.width)/2;
				numbersClip.y = Number(xmlData.numbers.@word_y);
			}
			targetClip.addChild(numbersClip);
		}
		private function addAnswer():void {
			var answer:MovieClip = targetClip.getChildByName("answer") as MovieClip;
			if(answer!=null) targetClip.removeChild(answer);
			answer = drawPage(Number(xmlData.answer.@width),Number(xmlData.answer.@height),Number(xmlData.answer.@bgColor),((xmlData.answer.@bgColor=="")?0:1), Number(xmlData.answer.@borderSize), Number(xmlData.answer.@borderColor));
			answer.name="answer";
			var txt:TextField = addTxt(" ");
			txt.name = "txt";
			answer.addChild(txt);
			answer.x=Number(xmlData.answer.@x);
			answer.y=Number(xmlData.answer.@y);
			targetClip.addChild(answer);
		}
		private function drawFeedback():void {
			var feedback:Feedback = new Feedback();
			feedback.name="feedback";
			feedback.x=Number(xmlData.feedback.@x);
			feedback.y=Number(xmlData.feedback.@y);
			feedback.visible=false;
			targetClip.addChild(feedback);
		}
		private function duplicateSmallPage(clone:MovieClip):MovieClip {
			var bmd:BitmapData=new BitmapData(clone.width, (clone.height),true,0x00000000);
			bmd.draw(clone);

			var holder:Bitmap = new Bitmap();
			holder.bitmapData=bmd;
			holder.smoothing=true;
			var obj:MovieClip = new MovieClip();
			obj.addChild(holder);
			return obj;
		}
		private function numberClicked(e:MouseEvent):void {
			if (!isDragging) {
				currRightPage=Number(pageArr[Number(e.target.name.split("_")[1])].no);
				var dupSmallPage:MovieClip=duplicateSmallPage(e.target as MovieClip);
				dupSmallPage.name="dupSmallPage";
				dupSmallPage.x = targetClip.mouseX - dupSmallPage.width/2;
				dupSmallPage.y = targetClip.mouseY - dupSmallPage.height/2;
				targetClip.addChild(dupSmallPage);
				var boundary:Rectangle=new Rectangle(targetClip.x,targetClip.y,710,390);
				dupSmallPage.startDrag(false,boundary);
			}
		}
		private function onStageClicked(e:MouseEvent):void {
			try
			{
				var cnt:Number=0;
				var ansClip:MovieClip = targetClip.getChildByName("answer") as MovieClip;
				var dupSmallPage:MovieClip = targetClip.getChildByName("dupSmallPage") as MovieClip;
				if((targetClip.mouseX >=ansClip.x && targetClip.mouseX <=ansClip.x+ansClip.width) && (targetClip.mouseY >=ansClip.y && targetClip.mouseY <=ansClip.y+ansClip.height)){
					cnt++;
					loadAnswerPage();
				}
				
				var numbersClip:MovieClip = targetClip.getChildByName("numbersClip") as MovieClip;
				for (var j:Number=0; j<pageArr.length; j++) {
					var number:MovieClip = numbersClip.getChildByName("number_"+j) as MovieClip;
					if((numbersClip.mouseX >=number.x && numbersClip.mouseX <=number.x+number.width) && (numbersClip.mouseY >=number.y && numbersClip.mouseY <=number.y+number.height)){					
						if(dupSmallPage!=null) targetClip.removeChild(dupSmallPage);
						isDragging = false;					
						number.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));					
						break;
					}
				}
				if(cnt==0)
				{
					targetClip.removeChild(dupSmallPage);
				}
			}catch(e:Error)
			{
			}
		}
		private function loadTray():void {
			var cakesClip:MovieClip = targetClip.getChildByName("cakesClip") as MovieClip;
			if(cakesClip!=null) targetClip.removeChild(cakesClip);
			cakesClip = new MovieClip();
			cakesClip.name = "cakesClip";
			var gap:Number = Number(xmlData.cakes.@gap);
			var cols:Number;
			var rows:Number;
			
			if(xmlData.cakes.@fillByRow.length()>0){
				rows = Number(xmlData.cakes.@fillByRow);
				cols =  Math.ceil(currLeftPage/rows);
			}
			if(xmlData.cakes.@fillByCol.length()>0){
				cols = Number(xmlData.cakes.@fillByCol);
				rows =  currLeftPage/cols;
			}
			
			for(var i=0;i<currLeftPage;i++){
				var cake:CakeClip = new CakeClip();
				cake.name = "cake_"+i;
				cake.x = (i%cols) * (cake.width + gap);
				cake.y = (Math.floor(i/cols) * (cake.height-10));
				cakesClip.addChild(cake);
			}
			cakesClip.x = Number(xmlData.cakes.@x);
			cakesClip.y = Number(xmlData.cakes.@y);
			targetClip.addChild(cakesClip);
		}
		private function loadAnswerPage():void {
			var dupSmallPage:MovieClip=targetClip.getChildByName("dupSmallPage") as MovieClip;
			dupSmallPage.stopDrag();
			targetClip.removeChild(dupSmallPage);
			var answer:MovieClip=targetClip.getChildByName("answer") as MovieClip;
			var txt:TextField = answer.getChildByName("txt") as TextField;
			txt.text = (targetClip.numBtn.currentFrame==3) ? pageArr[currRightPage-1].no : pageArr[currRightPage-1].word;
			var font:String = (targetClip.numBtn.currentFrame==3) ? xmlData.numbers.@no_font : xmlData.numbers.@word_font;
			var fontSize:Number = (targetClip.numBtn.currentFrame==3) ? Number(xmlData.numbers.@no_fontSize) : Number(xmlData.numbers.@word_fontSize);
			var fontColor:uint = (targetClip.numBtn.currentFrame==3) ? uint(xmlData.numbers.@no_fontColor) : uint(xmlData.numbers.@word_fontColor);
			
			var fnt=getDefinitionByName(font) as Class;
			var fon:Font=new fnt();
			
			changeFormat(txt,fon.fontName,fontSize,fontColor);
			txt.x = (answer.width - txt.width)/2;
			txt.y = (answer.height - txt.height)/2;
			trace(currLeftPage,currRightPage)
			if (currLeftPage==currRightPage) {
				showFeedback(true);
			} else {
				showFeedback(false);
			}
		}
		private function updateRangeVal(e:MouseEvent=null):void{
			var minValue:Number = Number(xmlData.numbers.number[0].@no);
			var maxValue:Number = Number(xmlData.numbers.number[xmlData.numbers.children().length()-1].@no);	
			if(e != null){
				var btnName:String = e.target.name;
				switch(btnName){
					case "fromUpBtn":
						if(fromRange<toRange){
							targetClip.rndBtn.fromTxt.text = ++fromRange;
							reset();
						}else{
							targetClip.rndBtn.fromTxt.text = fromRange;
						}
					break;
					
					case "fromDownBtn":
						if(fromRange>minValue){
							targetClip.rndBtn.fromTxt.text = --fromRange;
							reset();
						}else{
							targetClip.rndBtn.fromTxt.text = fromRange;
						}
					break;
					
					case "toUpBtn":
						if(toRange<maxValue){
							targetClip.rndBtn.toTxt.text = ++toRange;
							reset();
						}else{
							targetClip.rndBtn.toTxt.text = toRange;
						}
					break;
					
					case "toDownBtn":
						if(toRange>fromRange){
							targetClip.rndBtn.toTxt.text = --toRange;
							reset();
						}else{
							targetClip.rndBtn.toTxt.text = toRange;
						}
					break;
				}
			}else{
				targetClip.rndBtn.fromTxt.text = fromRange;
				targetClip.rndBtn.toTxt.text = toRange;
			}			
		}
		private function showFeedback(isCorrect:Boolean):void {
			var feedback:MovieClip=targetClip.getChildByName("feedback") as MovieClip;
			if (isCorrect) {
				feedback.gotoAndStop(2);
			} else {
				feedback.gotoAndStop(1);
			}
			feedback.visible=true;
		}
	}
}